using Indotalent.ConfigBackEnd.Exceptions;
using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Thirdparty.VendorGroup.Cqrs;

public class UpdateVendorGroupRequest
{
    public string? Id { get; set; }
    public string? Name { get; set; }
    public string? Description { get; set; }
    public DateTimeOffset? CreatedAt { get; set; }
    public string? CreatedBy { get; set; }
    public DateTimeOffset? UpdatedAt { get; set; }
    public string? UpdatedBy { get; set; }
}

public class UpdateVendorGroupResponse
{
    public string? Id { get; set; }
    public bool Success { get; set; }
}

public record UpdateVendorGroupCommand(UpdateVendorGroupRequest Data) : IRequest<UpdateVendorGroupResponse>;

public class UpdateVendorGroupHandler : IRequestHandler<UpdateVendorGroupCommand, UpdateVendorGroupResponse>
{
    private readonly AppDbContext _context;

    public UpdateVendorGroupHandler(AppDbContext context) => _context = context;

    public async Task<UpdateVendorGroupResponse> Handle(UpdateVendorGroupCommand request, CancellationToken cancellationToken)
    {
        var isExists = await _context.VendorGroup
            .AnyAsync(x => x.Name == request.Data.Name && x.Id != request.Data.Id, cancellationToken);

        if (isExists)
        {
            throw new AlreadyExistsException("Vendor Group", request.Data.Name ?? string.Empty);
        }

        var entity = await _context.VendorGroup
            .FirstOrDefaultAsync(x => x.Id == request.Data.Id, cancellationToken);

        if (entity == null)
        {
            return new UpdateVendorGroupResponse { Id = request.Data.Id, Success = false };
        }

        entity.Name = request.Data.Name;
        entity.Description = request.Data.Description;

        await _context.SaveChangesAsync(cancellationToken);

        return new UpdateVendorGroupResponse
        {
            Id = entity.Id,
            Success = true
        };
    }
}